# Mac OS X 10.7 Lion 〜 macOS 10.12 Sierra インストールpkg -> iso
# 2023/11/23作成 「Macのアンチョコ」 https://yama-mac.com/

# macOSのバージョンをインプット
echo ""
echo "macOSバージョンを入力（以下の1から6の半角整数を入力してから、returnキー押下）"
echo "1 = 10.7 Lion、2 = 10.8 Mountain Lion、3 = 10.9 Mavericks"
echo "4 = 10.10 Yosemite、5 = 10.11 El Capitan、6 = 10.12 Sierra"

read os_version

# 入力チェックと、作成するISOの名前を設定
case "$os_version" in
	1 ) echo "1 = 10.7 Lionが入力されました。"
	os_version_name="10.7-Lion";;
	2 ) echo "2 = 10.8 Mountain Lionが入力されました。"
	os_version_name="10.8-Mountain-Lion";;
	3 ) echo "3 = 10.9 Mavericksが入力されました。"
	os_version_name="10.9-Mavericks";;
	4 ) echo "4 = 10.10 Yosemiteが入力されました。"
	os_version_name="10.10-Yosemite";;
	5 ) echo "5 = 5 = 10.11 El Capitanが入力されました。"
	os_version_name="10.11-El-Capitan";;
	6 ) echo "6 = 10.12 Sierraが入力されました。"
	os_version_name="10.12-Sierra";;
* ) echo "1から6の半角整数以外が入力されたので、スクリプトを中断します。"
	exit;;
esac
iso_name=$os_version_name"-pkg-to-iso.iso"

# 読み出し元のpkgの名前を設定
case "$os_version" in
	[1-5] ) pkg_name="InstallMacOSX.pkg";;
	6 ) pkg_name="InstallOS.pkg";;
esac

# BaseSystemのディスクラベルを設定
case "$os_version" in
	[1-3] ) base_system_label="Mac OS X Base System";;
	[4-6] ) base_system_label="OS X Base System";;
esac

# pkgファイルを圧縮解除して、フォルダに展開
pkgutil --expand ~/Desktop/$pkg_name ~/Desktop/tmp_Installer

# 展開したパッケージ内のフォルダに移動
cd ~/Desktop/tmp_Installer/$pkg_name

# tarコマンドで解凍・展開
tar -xf Payload

# 作業用イメージファイルを作成して、マウント
hdiutil create -o /tmp/tmp_iso.cdr -size 7316m -layout SPUD -fs HFS+J
hdiutil attach /tmp/tmp_iso.cdr.dmg -noverify -nobrowse -mountpoint /Volumes/iso

# 復元元のBaseSystem.dmgをマウントして、復元
hdiutil attach InstallESD.dmg -noverify -nobrowse -mountpoint /Volumes/esd
asr restore -source /Volumes/esd/BaseSystem.dmg -target /Volumes/iso -noprompt -noverify -erase

# シンボリックリンクを削除して、実ファイルをコピー（復元の結果、復元先のマウント名が変わっていることに注意）
case "$os_version" in
	[1-3] ) 
		rm "/Volumes/Mac OS X Base System/System/Installation/Packages"
		cp -rp "/Volumes/esd/Packages" "/Volumes/Mac OS X Base System/System/Installation"
		;;
	[4-6] ) 
		rm -r "/Volumes/OS X Base System/System/Installation/Packages"
		cp -rp "/Volumes/esd/Packages" "/Volumes/OS X Base System/System/Installation"
		;;
esac

# BaseSystem関連2ファイルを、ルートディレクトリにコピー
case "$os_version" in
	[1-3] ) 
		cp -rp /Volumes/esd/BaseSystem.chunklist "/Volumes/Mac OS X Base System/"
		cp -rp /Volumes/esd/BaseSystem.dmg "/Volumes/Mac OS X Base System/"
		;;
	[4-6] ) 
		cp -rp /Volumes/esd/BaseSystem.chunklist "/Volumes/OS X Base System/"
		cp -rp /Volumes/esd/BaseSystem.dmg "/Volumes/OS X Base System/"
		;;
esac

# マウント中のボリュームを、アンマウント
hdiutil detach /Volumes/esd
case "$os_version" in
	[1-3] ) 
		hdiutil detach "/Volumes/Mac OS X Base System/"
		;;
	[4-6] ) 
		hdiutil detach "/Volumes/OS X Base System/"
		;;
esac

# 作業用イメージファイルを、ISOイメージに変換
hdiutil convert /tmp/tmp_iso.cdr.dmg -format UDTO -o /tmp/tmp_iso.iso

# ISOイメージの名前と保存先を変更
mv /tmp/tmp_iso.iso.cdr ~/Desktop/$iso_name

# 作業用フォルダ・作業用イメージファイルを削除
rm -rf ~/Desktop/tmp_Installer
rm /tmp/tmp_iso.cdr.dmg